/**
 * Created by dave on 16/1/21.
 */
'use strict';
var express          = require('express');
var Application      = require('./router');
var app              = new express();
var USE_LOCAL_SERVER = false;
global.UNIT_TEST     = false;

var localApp;
if (USE_LOCAL_SERVER) {
    var bodyParser   = require('body-parser');
    var cookieParser = require('cookie-parser');
    localApp         = new express();
    localApp.use(cookieParser());
    localApp.use(bodyParser.urlencoded({extended: false}));
    localApp.use(bodyParser.json());
    localApp.use(bodyParser.text({type: 'text/*'}));
    var mysql = require('@gopalroy/mysql-pool');
    mysql.config({
        host: 'localhost',
        user: 'root',
        password: 'YOURNEWPASSWORD',
        database: 'soling_in_car'
        timezone: '0000'
    });
    mysql.enableTrace(true);
}

app.use('/',       Application.userRouter);
app.use('/admin',  Application.adminRouter);
app.use('/',       express.static(__dirname + '/static'));

if (USE_LOCAL_SERVER) {
    localApp.use('/fleet-wechat', app);
    localApp.listen(8011, function() {
        console.log('server started at port: ' + 8011);
    });
}
module.exports = app;
