/**
 * Created by dave on 16/2/2 10:14.
 */
'use strict';
var moment = require('moment');
var mysql  = require('@gopalroy/mysql-pool');
var Utils  = require('./Utils');

var Admin = {
        name: 'Admin',
        org : {name: 'fleet-test', short_name: 'fleet-test', openid: 'Server_openId_456', biz_mode: 1}
    },
    self  = Admin;
module.exports = self;
/*Org*/
self.getOrgsG =
function*(filter, sortBy, pageSize, nextMarker) {
    return yield Utils.commonSelectG('t_4s', filter, sortBy, pageSize, nextMarker);
};

self.getOrgsCountG =
function*(filter) {
    return yield Utils.commonCountG('t_4s', filter);
};

self.deleteOrgsG =
function*(id) {
    return yield mysql.pool.queryP('DELETE FROM t_4s WHERE id = ?', [id]);
};
/*Driver*/
self.addDriverG =
function*(driver) {
    //var driver = Utils.extract(driver, [s4_id, name, pwd, nick, phone]);
    return (yield mysql.pool.queryP('INSERT t_staff SET ?', [driver])).insertId;
};

self.deleteDriverG =
function*(id) {
    yield mysql.pool.queryP('DELETE FROM t_staff WHERE id = ?', [id]);
};

self.updateDriverG =
function*(driver) {
    yield Utils.commonUpdateG('t_staff', driver);
};

self.getDriversG =
function*(filter, sortBy, pageSize, nextMarker) {
    filter = filter || {};
    filter.biz_mode = 1;
    var query = Utils.makeQuerySql('SELECT F.* FROM t_staff F JOIN t_4s S ON F.s4_id = S.id',
                    filter, sortBy, pageSize, nextMarker);
    yield mysql.pool.queryP(query.sql, query.args);
};

self.getDriversCountG =
function*(filter) {
    yield Utils.commonCountG('t_staff' , filter);
};
/*Car*/
self.addCarG =
function*(car) {
    return (yield mysql.pool.queryP('INSERT t_car SET ?', [car])).insertId;
};

self.deleteCarG =
function*(id) {
    yield mysql.pool.queryP('DELETE FROM t_car WHERE id = ?', [id]);
};

self.updateCarG =
function*(car) {
    yield Utils.commonUpdateG('t_car', car);
};

self.getCarsG =
function*(filter, sortBy, pageSize, nextMarker) {
    yield Utils.commonSelectG('t_car', filter, sortBy, pageSize, nextMarker);
};

self.getCarsCountG =
function*(filter) {
    yield Utils.commonCountG('t_car', filter);
};
/*Dispatch*/
self.addDispatchG =
function*(dispatch) {
    return (yield mysql.pool.queryP('INSERT t_disp_team SET ?', [dispatch])).insertId;
};

self.deleteDispatchG =
function*(id) {
    yield mysql.pool.queryP('DELETE FROM t_disp_team WHERE id = ?', [id]);
};

self.getDispatchesG =
function*(filter, sortBy, pageSize, nextMarker) {
    yield Utils.commonSelectG('t_disp_team', filter, sortBy, pageSize, nextMarker);
};

self.getDispatchesCountG =
function*(filter) {
    yield Utils.commonCountG('t_disp_team', filter);
};
/*Trip*/
self.addTripG =
function*(trip) {
    return (yield mysql.pool.queryP('INSERT t_obd_drive SET ?', [trip])).insertId;
};

self.deleteTripG =
function*(id) {
    yield mysql.pool.queryP('DELETE FROM t_obd_drive WHERE id = ?', [id]);
};

self.getTripsG =
function*(filter, sortBy, pageSize, nextMarker) {
    yield Utils.commonSelectG('t_obd_drive', filter, sortBy, pageSize, nextMarker);
};

self.getTripsCountG =
function*(filter) {
    yield Utils.commonCountG('t_obd_drive', filter);
};
