/**
 * Created by dave on 16/2/3 14:11.
 */
'use strict';
var co = require('co');
var request = require('request');
var querysting = require('querystring');

var Weixin = {
        name                 : 'Weixin',
        token                : 'YCCD2016INCAR',
        aesKey               : 'GqFVkVMDZQ38QAkBcAOng9vu5wT3M3N9IzB5SY6VjPZ',
        appId                : 'wxdba34e3c3410eb4f',
        appSecret            : '19b8ce039b8d336063c49f9779bf6e29',
        templateIdForDispatch: 'RgTsqQLZuGEXDXU_cxEsjE_fDCFm47wVMPuwr9r__UY'
    },
    self       = Weixin;
module.exports = self;

self.getAccessTokenG =
function*() {
    var url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=" + self.appId + "&secret=" + self.appSecret;
    if (self.accessToken == null || new Date().getTime() > self.accessTokenTime + (2*3600 - 600)*1000) {
        return yield new Promise((resolve, reject) => {
            request(url, function(err, res) {
                if (!err) {
                    self.accessToken = JSON.parse(res.body).access_token;
                    self.accessTokenTime = new Date().getTime();
                    resolve(self.accessToken);
                } else {
                    reject(err);
                }
            });
        });
    } else {
        return yield Promise.resolve(self.accessToken);
    }
};

self.getOpenIdG =
function*(code) {
    var url = `https://api.weixin.qq.com/sns/oauth2/access_token?appid=${self.appId}&secret=${self.appSecret}&code=${code}&grant_type=authorization_code`;
    return yield new Promise((resolve, reject) => {
        request.get({url: url, json: true}, function(err, res) {
            if (!err) {
                resolve(res.body.openid);
            } else {
                reject(err);
            }
        });
    });
};

self.sendTemplateMsgForDispatchG =
function*(openid, json) {
    var url      = 'https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=' + (yield self.getAccessTokenG());
    var postData = {
        touser     : openid,
        template_id: self.templateIdForDispatch,
        data       : {
            first   : {
                value: '你好,你当前用车信息：',
                color: "#173177"
            },
            keyword1: {
                value: json.license,
                color: "#173177"
            },
            keyword2: {
                value: json.dispatch_time,
                color: "#173177"
            },
            keyword3: {
                value: json.recover_time,
                color: "#173177"
            },
            keyword4: {
                value: (json.total_mileage || 0).toFixed(1) + '公里',
                color: "#173177"
            },
            keyword5: {
                value: (json.total_oil || 0).toFixed(1) + 'L',
                color: "#173177"
            },
            remark  : {
                value: '更多信息，请点击菜单: 我的信息 > 出车记录',
                color: "#173177"
            }
        }
    };
    return yield new Promise((resolve, reject) => {
        request.post({url: url, body: postData, json: true}, function (err, response) {
            if (!err) {
                resolve(response.body);
            } else {
                reject(err);
            }
        });
    });
};

self.createMenuG =
function*() {
    var menu = {
        button: [{
            name      : '出车还车',
            sub_button: [{
                type: 'scancode_waitmsg',
                name: '出车',
                key : 'menu_scan_to_take_car'
            }, {
                type: 'click',
                name: '还车',
                key : 'menu_return_car'
            }, {
                type: 'click',
                name: '当前用车',
                key : 'menu_get_status'
            }]
        }, {
            name      : '我的信息',
            sub_button: [{
                type: 'view',
                name: '出车记录',
                url : 'https://open.weixin.qq.com/connect/oauth2/authorize?' + querysting.stringify({
                    appid        : self.appId,
                    redirect_uri : 'http://service.incardata.com.cn/fleet-wechat/driver',
                    response_type: 'code',
                    scope        : 'snsapi_base',
                    state        : 1
                }) + '#wechat_redirect'
            },
            //    {
            //    type: 'view',
            //    name: '我的分析',
            //    url : 'http://www.baidu.com'
            //},
                {
                type: 'click',
                name: '个人信息',
                key : 'menu_get_profile'
            }, {
                type: 'click',
                name: '绑定帐户',
                key : 'menu_prepare_to_bind_account'
            }]
        }]
    };
    var url  = "https://api.weixin.qq.com/cgi-bin/menu/create?access_token=" + (yield self.getAccessTokenG());
    return yield new Promise((resolve, reject) => {
        request.post({url: url, body: new Buffer(JSON.stringify(menu))}, function (err, response) {
            if (!err) {
                resolve(response.body);
            } else {
                reject(err);
            }
        });
    });
};

self.getMenuG =
function*() {
    var url = "https://api.weixin.qq.com/cgi-bin/menu/get?access_token=" + (yield self.getAccessTokenG());
    return yield new Promise((resolve, reject) => {
        request.get({url: url, json: true}, function (err, response) {
            if (!err) {
                resolve(response.body);
            } else {
                reject(err);
            }
        });
    });
};

self.deleteMenuG =
function*() {
    var url = "https://api.weixin.qq.com/cgi-bin/menu/delete?access_token=" + (yield self.getAccessTokenG());
    return yield new Promise((resolve, reject) => {
        request.get({url: url, json: true}, function(err, response) {
            if (!err) {
                resolve(response.body);
            } else {
                reject(err);
            }
        });
    });
};
