/**
 * Created by dave on 16/2/2 09:51.
 */
'use strict';
var co      = require('co');
var moment  = require('moment');
var express = require('express');
var Admin   = require('../lib').Admin;
var Qrcode  = require('../lib').Qrcode;
var Utils   = require('../lib').Utils;

var AdminRouter = {
        name   : 'AdminRouter',
        context: '/'
    },
    self        = AdminRouter;
module.exports  = self;

self.encodeCarLicense =
function(req, res) {
    var license = req.query.license,
        encoded = Qrcode.encodeCarLicense(license);
    res.json({status: 'success', result: encoded});
};

self.getDrivers =
function(req, res) {
    var args = Utils.makeQueryArgs(req.query);
    co(function*() {
        var result = yield [Admin.getDriversCountG(args.filter),
                            Admin.getDriversG(args.filter, 'id-', args.pageSize, args.nextMarker)];
        res.json({status: 'success', drivers: result[1], count: result[1].length, total: result[0]});
    }).catch(ex => {
        console.log('英卡车队@' + moment().format('MM-DD HH:mm:ss') + '[' + __filename + ']: ' + ex.stack);
        res.status(500).json({status: 'failed', error: 'SYSTEM_ERROR', message: ex.stack});
    });
};

self.addDriver =
function(req, res) {

};

self.updateDriver =
function(req, res) {

};

self.deleteDriver =
function(req, res) {

};

self.getCars =
function(req, res) {

};

self.addCar =
function(req, res) {

};

self.updateCar =
function(req, res) {

};

self.deleteCar =
function(req, res) {

};

self.getDispatches =
function(req, res) {

};

self.addDispatch =
function(req, res) {

};

self.deleteDispatch =
function(req, res) {

};

self.getTrips =
function(req, res) {

};

self.addTrip =
function(req, res) {

};

self.deleteTrip =
function(req, res) {

};

self.getAdminRouter =
function() {
    if (!self.adminRouter) {
        self.adminRouter = new express();
        self.adminRouter.get('/encodeCarLicense', self.encodeCarLicense);
    }
    return self.adminRouter;
};