/**
 * Created by dave on 16/2/2 10:41.
 */
'use strict';
var bulk        = require('bulk-require');
var express     = require('express');
var modules     = bulk(__dirname, ['./**/!(*index|*.spec).js']);
var Application = {userRouter: new express(), adminRouter: new express()};

Object.keys(modules).forEach(key => {
    let item = modules[key];
    if (!item) return;
    if (item.name) {
        Application[item.name] = item;
    }
    if (item.context && item.getUserRouter) {
        Application.userRouter.use(item.context, item.getUserRouter());
    }
    if (item.context && item.getAdminRouter) {
        Application.adminRouter.use(item.context, item.getAdminRouter());
    }
});

module.exports = Application;