/**
 * Created by dave on 16/2/1.
 */
'use strict';
var mysql = require('@gopalroy/mysql-pool');

var TestDb = {},
    self   = TestDb;

self.org    = {name: 'fleet-test-0000', short_name: 'fleet-test-0000', openid: 'Server_openId_456', biz_mode: 1};
self.driver = {name: '测试用户0000', pwd: '--', nick: '测试0000', phone: '18800001111', wx_openid: 'Test_openId_123'};
self.car    = {license: '测Z123456', obd_code: 'fleet-test-obd-0000'};
self.initG =
function*() {
    var org = (yield mysql.pool.queryP('SELECT * FROM t_4s WHERE short_name = ?', [self.org.short_name]))[0];
    if (org) {
        self.org = org;
        console.log('使用已有Org: ' + self.org.id);
    } else {
        self.org.id = (yield mysql.pool.queryP('INSERT t_4s SET ?', [self.org])).insertId;
        console.log('创建Org: ' + self.org.id);
    }

    var driver = (yield mysql.pool.queryP('SELECT * FROM t_staff WHERE phone = ? AND s4_id = ?', [self.driver.phone, self.org.id]))[0];
    if (driver) {
        self.driver = driver;
        console.log('使用已有Driver: ' + self.driver.id);
    } else {
        self.driver.s4_id = self.org.id;
        self.driver.id = (yield mysql.pool.queryP('INSERT t_staff SET ?', [self.driver])).insertId;
        console.log('创建Driver: ' + self.driver.id);
    }

    var car = (yield mysql.pool.queryP('SELECT * FROM t_car WHERE license = ? AND s4_id = ?', [self.car.license, self.org.id]))[0];
    if (car) {
        self.car = car;
        console.log('使用已有Car: ' + self.car.id);
    } else {
        self.car.s4_id = self.org.id;
        self.car.id = (yield mysql.pool.queryP('INSERT t_car SET ?', [self.car])).insertId;
        console.log('创建Car: ' + self.car.id);
    }
};

self.cleanG =
function*() {
    yield mysql.pool.queryP('DELETE FROM t_car WHERE id = ?', [self.car.id]);
    console.log("\n删除Car");
    yield mysql.pool.queryP('DELETE FROM t_staff WHERE id = ?', [self.driver.id]);
    console.log("删除Driver");
    yield mysql.pool.queryP('DELETE FROM t_4s WHERE id = ?', [self.org.id]);
    console.log("删除Org");
};

module.exports = self;
